from typing import Any, Dict, Tuple
from flask import Response
from jsonpickle import encode


def build_response(
        data: Any,
        status_code: int = 200,
        message: str = None) -> Tuple[Dict, int]:

    is_error = status_code >= 400 or data is Exception

    with_message = {
        'message': message
    } if message else {}

    decide_body = {
        'result': data.message if data is Exception else data
    } if not is_error else {
        'error': data
    }

    response = encode({
        'success': not is_error,
        **decide_body,
        **with_message
    })
    return Response(response=response, status=status_code)
